//go:build !disable_pgv

// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: envoy/extensions/filters/http/credential_injector/v3/credential_injector.proto

package credential_injectorv3

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on CredentialInjector with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *CredentialInjector) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on CredentialInjector with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// CredentialInjectorMultiError, or nil if none found.
func (m *CredentialInjector) ValidateAll() error {
	return m.validate(true)
}

func (m *CredentialInjector) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	// no validation rules for Overwrite

	// no validation rules for AllowRequestWithoutCredential

	if m.GetCredential() == nil {
		err := CredentialInjectorValidationError{
			field:  "Credential",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if all {
		switch v := interface{}(m.GetCredential()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, CredentialInjectorValidationError{
					field:  "Credential",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, CredentialInjectorValidationError{
					field:  "Credential",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetCredential()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return CredentialInjectorValidationError{
				field:  "Credential",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if len(errors) > 0 {
		return CredentialInjectorMultiError(errors)
	}

	return nil
}

// CredentialInjectorMultiError is an error wrapping multiple validation errors
// returned by CredentialInjector.ValidateAll() if the designated constraints
// aren't met.
type CredentialInjectorMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m CredentialInjectorMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m CredentialInjectorMultiError) AllErrors() []error { return m }

// CredentialInjectorValidationError is the validation error returned by
// CredentialInjector.Validate if the designated constraints aren't met.
type CredentialInjectorValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e CredentialInjectorValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e CredentialInjectorValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e CredentialInjectorValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e CredentialInjectorValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e CredentialInjectorValidationError) ErrorName() string {
	return "CredentialInjectorValidationError"
}

// Error satisfies the builtin error interface
func (e CredentialInjectorValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sCredentialInjector.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = CredentialInjectorValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = CredentialInjectorValidationError{}
