//go:build !ignore_autogenerated

// Copyright 2021 Ambassador Labs.  All rights reserved
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by controller-gen. DO NOT EDIT.

package v3alpha1

import (
	"encoding/json"
	corev1 "k8s.io/api/core/v1"
	"k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
)

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ACMEProviderSpec) DeepCopyInto(out *ACMEProviderSpec) {
	*out = *in
	if in.PrivateKeySecret != nil {
		in, out := &in.PrivateKeySecret, &out.PrivateKeySecret
		*out = new(corev1.LocalObjectReference)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ACMEProviderSpec.
func (in *ACMEProviderSpec) DeepCopy() *ACMEProviderSpec {
	if in == nil {
		return nil
	}
	out := new(ACMEProviderSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AddedHeader) DeepCopyInto(out *AddedHeader) {
	*out = *in
	if in.Append != nil {
		in, out := &in.Append, &out.Append
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AddedHeader.
func (in *AddedHeader) DeepCopy() *AddedHeader {
	if in == nil {
		return nil
	}
	out := new(AddedHeader)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AdditionalLogHeaders) DeepCopyInto(out *AdditionalLogHeaders) {
	*out = *in
	if in.DuringRequest != nil {
		in, out := &in.DuringRequest, &out.DuringRequest
		*out = new(bool)
		**out = **in
	}
	if in.DuringResponse != nil {
		in, out := &in.DuringResponse, &out.DuringResponse
		*out = new(bool)
		**out = **in
	}
	if in.DuringTrailer != nil {
		in, out := &in.DuringTrailer, &out.DuringTrailer
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AdditionalLogHeaders.
func (in *AdditionalLogHeaders) DeepCopy() *AdditionalLogHeaders {
	if in == nil {
		return nil
	}
	out := new(AdditionalLogHeaders)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AmbassadorConfigSpec) DeepCopyInto(out *AmbassadorConfigSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.Features != nil {
		in, out := &in.Features, &out.Features
		*out = new(Features)
		**out = **in
	}
	if in.LoadBalancer != nil {
		in, out := &in.LoadBalancer, &out.LoadBalancer
		*out = new(LoadBalancer)
		(*in).DeepCopyInto(*out)
	}
	if in.CircuitBreakers != nil {
		in, out := &in.CircuitBreakers, &out.CircuitBreakers
		*out = new(CircuitBreaker)
		(*in).DeepCopyInto(*out)
	}
	if in.ErrorResponseOverrides != nil {
		in, out := &in.ErrorResponseOverrides, &out.ErrorResponseOverrides
		*out = make([]ErrorResponseOverride, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.HeaderCaseOverrides != nil {
		in, out := &in.HeaderCaseOverrides, &out.HeaderCaseOverrides
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.RetryPolicy != nil {
		in, out := &in.RetryPolicy, &out.RetryPolicy
		*out = new(RetryPolicy)
		(*in).DeepCopyInto(*out)
	}
	if in.Cors != nil {
		in, out := &in.Cors, &out.Cors
		*out = new(CORS)
		(*in).DeepCopyInto(*out)
	}
	if in.ClusterRequestTimeout != nil {
		in, out := &in.ClusterRequestTimeout, &out.ClusterRequestTimeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.ClusterIdleTimeout != nil {
		in, out := &in.ClusterIdleTimeout, &out.ClusterIdleTimeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.ClusterMaxConnectionLifetime != nil {
		in, out := &in.ClusterMaxConnectionLifetime, &out.ClusterMaxConnectionLifetime
		*out = new(MillisecondDuration)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AmbassadorConfigSpec.
func (in *AmbassadorConfigSpec) DeepCopy() *AmbassadorConfigSpec {
	if in == nil {
		return nil
	}
	out := new(AmbassadorConfigSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AmbassadorConfigStatus) DeepCopyInto(out *AmbassadorConfigStatus) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AmbassadorConfigStatus.
func (in *AmbassadorConfigStatus) DeepCopy() *AmbassadorConfigStatus {
	if in == nil {
		return nil
	}
	out := new(AmbassadorConfigStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in AmbassadorID) DeepCopyInto(out *AmbassadorID) {
	{
		in := &in
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AmbassadorID.
func (in AmbassadorID) DeepCopy() AmbassadorID {
	if in == nil {
		return nil
	}
	out := new(AmbassadorID)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AuthService) DeepCopyInto(out *AuthService) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AuthService.
func (in *AuthService) DeepCopy() *AuthService {
	if in == nil {
		return nil
	}
	out := new(AuthService)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *AuthService) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AuthServiceIncludeBody) DeepCopyInto(out *AuthServiceIncludeBody) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AuthServiceIncludeBody.
func (in *AuthServiceIncludeBody) DeepCopy() *AuthServiceIncludeBody {
	if in == nil {
		return nil
	}
	out := new(AuthServiceIncludeBody)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AuthServiceList) DeepCopyInto(out *AuthServiceList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]AuthService, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AuthServiceList.
func (in *AuthServiceList) DeepCopy() *AuthServiceList {
	if in == nil {
		return nil
	}
	out := new(AuthServiceList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *AuthServiceList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AuthServiceSpec) DeepCopyInto(out *AuthServiceSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.Timeout != nil {
		in, out := &in.Timeout, &out.Timeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.AllowedRequestHeaders != nil {
		in, out := &in.AllowedRequestHeaders, &out.AllowedRequestHeaders
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.AllowedAuthorizationHeaders != nil {
		in, out := &in.AllowedAuthorizationHeaders, &out.AllowedAuthorizationHeaders
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.AddAuthHeaders != nil {
		in, out := &in.AddAuthHeaders, &out.AddAuthHeaders
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.AllowRequestBody != nil {
		in, out := &in.AllowRequestBody, &out.AllowRequestBody
		*out = new(bool)
		**out = **in
	}
	if in.AddLinkerdHeaders != nil {
		in, out := &in.AddLinkerdHeaders, &out.AddLinkerdHeaders
		*out = new(bool)
		**out = **in
	}
	if in.FailureModeAllow != nil {
		in, out := &in.FailureModeAllow, &out.FailureModeAllow
		*out = new(bool)
		**out = **in
	}
	if in.IncludeBody != nil {
		in, out := &in.IncludeBody, &out.IncludeBody
		*out = new(AuthServiceIncludeBody)
		**out = **in
	}
	if in.StatusOnError != nil {
		in, out := &in.StatusOnError, &out.StatusOnError
		*out = new(AuthServiceStatusOnError)
		**out = **in
	}
	if in.CircuitBreakers != nil {
		in, out := &in.CircuitBreakers, &out.CircuitBreakers
		*out = make([]*CircuitBreaker, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(CircuitBreaker)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.V2ExplicitTLS != nil {
		in, out := &in.V2ExplicitTLS, &out.V2ExplicitTLS
		*out = new(V2ExplicitTLS)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AuthServiceSpec.
func (in *AuthServiceSpec) DeepCopy() *AuthServiceSpec {
	if in == nil {
		return nil
	}
	out := new(AuthServiceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AuthServiceStatusOnError) DeepCopyInto(out *AuthServiceStatusOnError) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AuthServiceStatusOnError.
func (in *AuthServiceStatusOnError) DeepCopy() *AuthServiceStatusOnError {
	if in == nil {
		return nil
	}
	out := new(AuthServiceStatusOnError)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *CORS) DeepCopyInto(out *CORS) {
	*out = *in
	if in.Origins != nil {
		in, out := &in.Origins, &out.Origins
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Methods != nil {
		in, out := &in.Methods, &out.Methods
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Headers != nil {
		in, out := &in.Headers, &out.Headers
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Credentials != nil {
		in, out := &in.Credentials, &out.Credentials
		*out = new(bool)
		**out = **in
	}
	if in.ExposedHeaders != nil {
		in, out := &in.ExposedHeaders, &out.ExposedHeaders
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new CORS.
func (in *CORS) DeepCopy() *CORS {
	if in == nil {
		return nil
	}
	out := new(CORS)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *CircuitBreaker) DeepCopyInto(out *CircuitBreaker) {
	*out = *in
	if in.MaxConnections != nil {
		in, out := &in.MaxConnections, &out.MaxConnections
		*out = new(int)
		**out = **in
	}
	if in.MaxPendingRequests != nil {
		in, out := &in.MaxPendingRequests, &out.MaxPendingRequests
		*out = new(int)
		**out = **in
	}
	if in.MaxRequests != nil {
		in, out := &in.MaxRequests, &out.MaxRequests
		*out = new(int)
		**out = **in
	}
	if in.MaxRetries != nil {
		in, out := &in.MaxRetries, &out.MaxRetries
		*out = new(int)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new CircuitBreaker.
func (in *CircuitBreaker) DeepCopy() *CircuitBreaker {
	if in == nil {
		return nil
	}
	out := new(CircuitBreaker)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ConsulResolver) DeepCopyInto(out *ConsulResolver) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ConsulResolver.
func (in *ConsulResolver) DeepCopy() *ConsulResolver {
	if in == nil {
		return nil
	}
	out := new(ConsulResolver)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ConsulResolver) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ConsulResolverList) DeepCopyInto(out *ConsulResolverList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]ConsulResolver, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ConsulResolverList.
func (in *ConsulResolverList) DeepCopy() *ConsulResolverList {
	if in == nil {
		return nil
	}
	out := new(ConsulResolverList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ConsulResolverList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ConsulResolverSpec) DeepCopyInto(out *ConsulResolverSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ConsulResolverSpec.
func (in *ConsulResolverSpec) DeepCopy() *ConsulResolverSpec {
	if in == nil {
		return nil
	}
	out := new(ConsulResolverSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DevPortal) DeepCopyInto(out *DevPortal) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DevPortal.
func (in *DevPortal) DeepCopy() *DevPortal {
	if in == nil {
		return nil
	}
	out := new(DevPortal)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *DevPortal) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DevPortalContentSpec) DeepCopyInto(out *DevPortalContentSpec) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DevPortalContentSpec.
func (in *DevPortalContentSpec) DeepCopy() *DevPortalContentSpec {
	if in == nil {
		return nil
	}
	out := new(DevPortalContentSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DevPortalDocsSpec) DeepCopyInto(out *DevPortalDocsSpec) {
	*out = *in
	if in.Timeout != nil {
		in, out := &in.Timeout, &out.Timeout
		*out = new(MillisecondDuration)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DevPortalDocsSpec.
func (in *DevPortalDocsSpec) DeepCopy() *DevPortalDocsSpec {
	if in == nil {
		return nil
	}
	out := new(DevPortalDocsSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DevPortalList) DeepCopyInto(out *DevPortalList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]DevPortal, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DevPortalList.
func (in *DevPortalList) DeepCopy() *DevPortalList {
	if in == nil {
		return nil
	}
	out := new(DevPortalList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *DevPortalList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DevPortalSearchSpec) DeepCopyInto(out *DevPortalSearchSpec) {
	*out = *in
	if in.Enabled != nil {
		in, out := &in.Enabled, &out.Enabled
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DevPortalSearchSpec.
func (in *DevPortalSearchSpec) DeepCopy() *DevPortalSearchSpec {
	if in == nil {
		return nil
	}
	out := new(DevPortalSearchSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DevPortalSelectorSpec) DeepCopyInto(out *DevPortalSelectorSpec) {
	*out = *in
	if in.MatchNamespaces != nil {
		in, out := &in.MatchNamespaces, &out.MatchNamespaces
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.MatchLabels != nil {
		in, out := &in.MatchLabels, &out.MatchLabels
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DevPortalSelectorSpec.
func (in *DevPortalSelectorSpec) DeepCopy() *DevPortalSelectorSpec {
	if in == nil {
		return nil
	}
	out := new(DevPortalSelectorSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DevPortalSpec) DeepCopyInto(out *DevPortalSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.Default != nil {
		in, out := &in.Default, &out.Default
		*out = new(bool)
		**out = **in
	}
	if in.Content != nil {
		in, out := &in.Content, &out.Content
		*out = new(DevPortalContentSpec)
		**out = **in
	}
	if in.Docs != nil {
		in, out := &in.Docs, &out.Docs
		*out = make([]*DevPortalDocsSpec, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(DevPortalDocsSpec)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.Selector != nil {
		in, out := &in.Selector, &out.Selector
		*out = new(DevPortalSelectorSpec)
		(*in).DeepCopyInto(*out)
	}
	if in.Search != nil {
		in, out := &in.Search, &out.Search
		*out = new(DevPortalSearchSpec)
		(*in).DeepCopyInto(*out)
	}
	if in.PreserveServers != nil {
		in, out := &in.PreserveServers, &out.PreserveServers
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DevPortalSpec.
func (in *DevPortalSpec) DeepCopy() *DevPortalSpec {
	if in == nil {
		return nil
	}
	out := new(DevPortalSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DocsInfo) DeepCopyInto(out *DocsInfo) {
	*out = *in
	if in.Ignored != nil {
		in, out := &in.Ignored, &out.Ignored
		*out = new(bool)
		**out = **in
	}
	if in.Timeout != nil {
		in, out := &in.Timeout, &out.Timeout
		*out = new(MillisecondDuration)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DocsInfo.
func (in *DocsInfo) DeepCopy() *DocsInfo {
	if in == nil {
		return nil
	}
	out := new(DocsInfo)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in DomainMap) DeepCopyInto(out *DomainMap) {
	{
		in := &in
		*out = make(DomainMap, len(*in))
		for key, val := range *in {
			var outVal []MappingLabelGroup
			if val == nil {
				(*out)[key] = nil
			} else {
				inVal := (*in)[key]
				in, out := &inVal, &outVal
				*out = make(MappingLabelGroupsArray, len(*in))
				for i := range *in {
					if (*in)[i] != nil {
						in, out := &(*in)[i], &(*out)[i]
						*out = make(MappingLabelGroup, len(*in))
						for key, val := range *in {
							var outVal []MappingLabelSpecifier
							if val == nil {
								(*out)[key] = nil
							} else {
								inVal := (*in)[key]
								in, out := &inVal, &outVal
								*out = make(MappingLabelsArray, len(*in))
								for i := range *in {
									(*in)[i].DeepCopyInto(&(*out)[i])
								}
							}
							(*out)[key] = outVal
						}
					}
				}
			}
			(*out)[key] = outVal
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DomainMap.
func (in DomainMap) DeepCopy() DomainMap {
	if in == nil {
		return nil
	}
	out := new(DomainMap)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DriverConfig) DeepCopyInto(out *DriverConfig) {
	*out = *in
	if in.AdditionalLogHeaders != nil {
		in, out := &in.AdditionalLogHeaders, &out.AdditionalLogHeaders
		*out = make([]*AdditionalLogHeaders, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(AdditionalLogHeaders)
				(*in).DeepCopyInto(*out)
			}
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DriverConfig.
func (in *DriverConfig) DeepCopy() *DriverConfig {
	if in == nil {
		return nil
	}
	out := new(DriverConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ErrorResponseOverride) DeepCopyInto(out *ErrorResponseOverride) {
	*out = *in
	in.Body.DeepCopyInto(&out.Body)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ErrorResponseOverride.
func (in *ErrorResponseOverride) DeepCopy() *ErrorResponseOverride {
	if in == nil {
		return nil
	}
	out := new(ErrorResponseOverride)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ErrorResponseOverrideBody) DeepCopyInto(out *ErrorResponseOverrideBody) {
	*out = *in
	if in.ErrorResponseTextFormat != nil {
		in, out := &in.ErrorResponseTextFormat, &out.ErrorResponseTextFormat
		*out = new(string)
		**out = **in
	}
	if in.ErrorResponseJsonFormat != nil {
		in, out := &in.ErrorResponseJsonFormat, &out.ErrorResponseJsonFormat
		*out = new(map[string]string)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]string, len(*in))
			for key, val := range *in {
				(*out)[key] = val
			}
		}
	}
	if in.ErrorResponseTextFormatSource != nil {
		in, out := &in.ErrorResponseTextFormatSource, &out.ErrorResponseTextFormatSource
		*out = new(ErrorResponseTextFormatSource)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ErrorResponseOverrideBody.
func (in *ErrorResponseOverrideBody) DeepCopy() *ErrorResponseOverrideBody {
	if in == nil {
		return nil
	}
	out := new(ErrorResponseOverrideBody)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ErrorResponseTextFormatSource) DeepCopyInto(out *ErrorResponseTextFormatSource) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ErrorResponseTextFormatSource.
func (in *ErrorResponseTextFormatSource) DeepCopy() *ErrorResponseTextFormatSource {
	if in == nil {
		return nil
	}
	out := new(ErrorResponseTextFormatSource)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Features) DeepCopyInto(out *Features) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Features.
func (in *Features) DeepCopy() *Features {
	if in == nil {
		return nil
	}
	out := new(Features)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *GRPCHealthCheck) DeepCopyInto(out *GRPCHealthCheck) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new GRPCHealthCheck.
func (in *GRPCHealthCheck) DeepCopy() *GRPCHealthCheck {
	if in == nil {
		return nil
	}
	out := new(GRPCHealthCheck)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HTTPHealthCheck) DeepCopyInto(out *HTTPHealthCheck) {
	*out = *in
	if in.AddRequestHeaders != nil {
		in, out := &in.AddRequestHeaders, &out.AddRequestHeaders
		*out = make(map[string]AddedHeader, len(*in))
		for key, val := range *in {
			(*out)[key] = *val.DeepCopy()
		}
	}
	if in.RemoveRequestHeaders != nil {
		in, out := &in.RemoveRequestHeaders, &out.RemoveRequestHeaders
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ExpectedStatuses != nil {
		in, out := &in.ExpectedStatuses, &out.ExpectedStatuses
		*out = make([]StatusRange, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HTTPHealthCheck.
func (in *HTTPHealthCheck) DeepCopy() *HTTPHealthCheck {
	if in == nil {
		return nil
	}
	out := new(HTTPHealthCheck)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HealthCheck) DeepCopyInto(out *HealthCheck) {
	*out = *in
	if in.Timeout != nil {
		in, out := &in.Timeout, &out.Timeout
		*out = new(v1.Duration)
		**out = **in
	}
	if in.Interval != nil {
		in, out := &in.Interval, &out.Interval
		*out = new(v1.Duration)
		**out = **in
	}
	if in.UnhealthyThreshold != nil {
		in, out := &in.UnhealthyThreshold, &out.UnhealthyThreshold
		*out = new(int)
		**out = **in
	}
	if in.HealthyThreshold != nil {
		in, out := &in.HealthyThreshold, &out.HealthyThreshold
		*out = new(int)
		**out = **in
	}
	in.HealthCheckLocation.DeepCopyInto(&out.HealthCheckLocation)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HealthCheck.
func (in *HealthCheck) DeepCopy() *HealthCheck {
	if in == nil {
		return nil
	}
	out := new(HealthCheck)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HealthCheckLocation) DeepCopyInto(out *HealthCheckLocation) {
	*out = *in
	if in.HTTPHealthCheck != nil {
		in, out := &in.HTTPHealthCheck, &out.HTTPHealthCheck
		*out = new(HTTPHealthCheck)
		(*in).DeepCopyInto(*out)
	}
	if in.GRPCHealthCheck != nil {
		in, out := &in.GRPCHealthCheck, &out.GRPCHealthCheck
		*out = new(GRPCHealthCheck)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HealthCheckLocation.
func (in *HealthCheckLocation) DeepCopy() *HealthCheckLocation {
	if in == nil {
		return nil
	}
	out := new(HealthCheckLocation)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Host) DeepCopyInto(out *Host) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	if in.Spec != nil {
		in, out := &in.Spec, &out.Spec
		*out = new(HostSpec)
		(*in).DeepCopyInto(*out)
	}
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Host.
func (in *Host) DeepCopy() *Host {
	if in == nil {
		return nil
	}
	out := new(Host)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Host) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HostBindingType) DeepCopyInto(out *HostBindingType) {
	*out = *in
	out.Namespace = in.Namespace
	if in.Selector != nil {
		in, out := &in.Selector, &out.Selector
		*out = new(v1.LabelSelector)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HostBindingType.
func (in *HostBindingType) DeepCopy() *HostBindingType {
	if in == nil {
		return nil
	}
	out := new(HostBindingType)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HostList) DeepCopyInto(out *HostList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Host, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HostList.
func (in *HostList) DeepCopy() *HostList {
	if in == nil {
		return nil
	}
	out := new(HostList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *HostList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HostSpec) DeepCopyInto(out *HostSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.DeprecatedSelector != nil {
		in, out := &in.DeprecatedSelector, &out.DeprecatedSelector
		*out = new(v1.LabelSelector)
		(*in).DeepCopyInto(*out)
	}
	if in.MappingSelector != nil {
		in, out := &in.MappingSelector, &out.MappingSelector
		*out = new(v1.LabelSelector)
		(*in).DeepCopyInto(*out)
	}
	if in.AcmeProvider != nil {
		in, out := &in.AcmeProvider, &out.AcmeProvider
		*out = new(ACMEProviderSpec)
		(*in).DeepCopyInto(*out)
	}
	if in.TLSSecret != nil {
		in, out := &in.TLSSecret, &out.TLSSecret
		*out = new(corev1.SecretReference)
		**out = **in
	}
	if in.RequestPolicy != nil {
		in, out := &in.RequestPolicy, &out.RequestPolicy
		*out = new(RequestPolicy)
		(*in).DeepCopyInto(*out)
	}
	if in.PreviewUrl != nil {
		in, out := &in.PreviewUrl, &out.PreviewUrl
		*out = new(PreviewURLSpec)
		(*in).DeepCopyInto(*out)
	}
	if in.TLSContext != nil {
		in, out := &in.TLSContext, &out.TLSContext
		*out = new(corev1.LocalObjectReference)
		**out = **in
	}
	if in.TLS != nil {
		in, out := &in.TLS, &out.TLS
		*out = new(TLSConfig)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HostSpec.
func (in *HostSpec) DeepCopy() *HostSpec {
	if in == nil {
		return nil
	}
	out := new(HostSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HostStatus) DeepCopyInto(out *HostStatus) {
	*out = *in
	if in.ErrorTimestamp != nil {
		in, out := &in.ErrorTimestamp, &out.ErrorTimestamp
		*out = (*in).DeepCopy()
	}
	if in.ErrorBackoff != nil {
		in, out := &in.ErrorBackoff, &out.ErrorBackoff
		*out = new(v1.Duration)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HostStatus.
func (in *HostStatus) DeepCopy() *HostStatus {
	if in == nil {
		return nil
	}
	out := new(HostStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *InsecureRequestPolicy) DeepCopyInto(out *InsecureRequestPolicy) {
	*out = *in
	if in.AdditionalPort != nil {
		in, out := &in.AdditionalPort, &out.AdditionalPort
		*out = new(int)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new InsecureRequestPolicy.
func (in *InsecureRequestPolicy) DeepCopy() *InsecureRequestPolicy {
	if in == nil {
		return nil
	}
	out := new(InsecureRequestPolicy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KeepAlive) DeepCopyInto(out *KeepAlive) {
	*out = *in
	if in.Probes != nil {
		in, out := &in.Probes, &out.Probes
		*out = new(int)
		**out = **in
	}
	if in.IdleTime != nil {
		in, out := &in.IdleTime, &out.IdleTime
		*out = new(int)
		**out = **in
	}
	if in.Interval != nil {
		in, out := &in.Interval, &out.Interval
		*out = new(int)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KeepAlive.
func (in *KeepAlive) DeepCopy() *KeepAlive {
	if in == nil {
		return nil
	}
	out := new(KeepAlive)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KubernetesEndpointResolver) DeepCopyInto(out *KubernetesEndpointResolver) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KubernetesEndpointResolver.
func (in *KubernetesEndpointResolver) DeepCopy() *KubernetesEndpointResolver {
	if in == nil {
		return nil
	}
	out := new(KubernetesEndpointResolver)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KubernetesEndpointResolver) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KubernetesEndpointResolverList) DeepCopyInto(out *KubernetesEndpointResolverList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KubernetesEndpointResolver, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KubernetesEndpointResolverList.
func (in *KubernetesEndpointResolverList) DeepCopy() *KubernetesEndpointResolverList {
	if in == nil {
		return nil
	}
	out := new(KubernetesEndpointResolverList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KubernetesEndpointResolverList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KubernetesEndpointResolverSpec) DeepCopyInto(out *KubernetesEndpointResolverSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KubernetesEndpointResolverSpec.
func (in *KubernetesEndpointResolverSpec) DeepCopy() *KubernetesEndpointResolverSpec {
	if in == nil {
		return nil
	}
	out := new(KubernetesEndpointResolverSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KubernetesServiceResolver) DeepCopyInto(out *KubernetesServiceResolver) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KubernetesServiceResolver.
func (in *KubernetesServiceResolver) DeepCopy() *KubernetesServiceResolver {
	if in == nil {
		return nil
	}
	out := new(KubernetesServiceResolver)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KubernetesServiceResolver) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KubernetesServiceResolverList) DeepCopyInto(out *KubernetesServiceResolverList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]KubernetesServiceResolver, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KubernetesServiceResolverList.
func (in *KubernetesServiceResolverList) DeepCopy() *KubernetesServiceResolverList {
	if in == nil {
		return nil
	}
	out := new(KubernetesServiceResolverList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *KubernetesServiceResolverList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KubernetesServiceResolverSpec) DeepCopyInto(out *KubernetesServiceResolverSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KubernetesServiceResolverSpec.
func (in *KubernetesServiceResolverSpec) DeepCopy() *KubernetesServiceResolverSpec {
	if in == nil {
		return nil
	}
	out := new(KubernetesServiceResolverSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Listener) DeepCopyInto(out *Listener) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	if in.Spec != nil {
		in, out := &in.Spec, &out.Spec
		*out = new(ListenerSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Listener.
func (in *Listener) DeepCopy() *Listener {
	if in == nil {
		return nil
	}
	out := new(Listener)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Listener) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ListenerList) DeepCopyInto(out *ListenerList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Listener, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ListenerList.
func (in *ListenerList) DeepCopy() *ListenerList {
	if in == nil {
		return nil
	}
	out := new(ListenerList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ListenerList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ListenerSpec) DeepCopyInto(out *ListenerSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.ProtocolStack != nil {
		in, out := &in.ProtocolStack, &out.ProtocolStack
		*out = make([]ProtocolStackElement, len(*in))
		copy(*out, *in)
	}
	in.HostBinding.DeepCopyInto(&out.HostBinding)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ListenerSpec.
func (in *ListenerSpec) DeepCopy() *ListenerSpec {
	if in == nil {
		return nil
	}
	out := new(ListenerSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LoadBalancer) DeepCopyInto(out *LoadBalancer) {
	*out = *in
	if in.Cookie != nil {
		in, out := &in.Cookie, &out.Cookie
		*out = new(LoadBalancerCookie)
		**out = **in
	}
	if in.SourceIp != nil {
		in, out := &in.SourceIp, &out.SourceIp
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LoadBalancer.
func (in *LoadBalancer) DeepCopy() *LoadBalancer {
	if in == nil {
		return nil
	}
	out := new(LoadBalancer)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LoadBalancerCookie) DeepCopyInto(out *LoadBalancerCookie) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LoadBalancerCookie.
func (in *LoadBalancerCookie) DeepCopy() *LoadBalancerCookie {
	if in == nil {
		return nil
	}
	out := new(LoadBalancerCookie)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LogService) DeepCopyInto(out *LogService) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LogService.
func (in *LogService) DeepCopy() *LogService {
	if in == nil {
		return nil
	}
	out := new(LogService)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *LogService) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LogServiceList) DeepCopyInto(out *LogServiceList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]LogService, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LogServiceList.
func (in *LogServiceList) DeepCopy() *LogServiceList {
	if in == nil {
		return nil
	}
	out := new(LogServiceList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *LogServiceList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LogServiceSpec) DeepCopyInto(out *LogServiceSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.DriverConfig != nil {
		in, out := &in.DriverConfig, &out.DriverConfig
		*out = new(DriverConfig)
		(*in).DeepCopyInto(*out)
	}
	if in.FlushIntervalTime != nil {
		in, out := &in.FlushIntervalTime, &out.FlushIntervalTime
		*out = new(SecondDuration)
		**out = **in
	}
	if in.FlushIntervalByteSize != nil {
		in, out := &in.FlushIntervalByteSize, &out.FlushIntervalByteSize
		*out = new(int)
		**out = **in
	}
	if in.GRPC != nil {
		in, out := &in.GRPC, &out.GRPC
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LogServiceSpec.
func (in *LogServiceSpec) DeepCopy() *LogServiceSpec {
	if in == nil {
		return nil
	}
	out := new(LogServiceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Mapping) DeepCopyInto(out *Mapping) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	if in.Status != nil {
		in, out := &in.Status, &out.Status
		*out = new(MappingStatus)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Mapping.
func (in *Mapping) DeepCopy() *Mapping {
	if in == nil {
		return nil
	}
	out := new(Mapping)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Mapping) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in MappingLabelGroup) DeepCopyInto(out *MappingLabelGroup) {
	{
		in := &in
		*out = make(MappingLabelGroup, len(*in))
		for key, val := range *in {
			var outVal []MappingLabelSpecifier
			if val == nil {
				(*out)[key] = nil
			} else {
				inVal := (*in)[key]
				in, out := &inVal, &outVal
				*out = make(MappingLabelsArray, len(*in))
				for i := range *in {
					(*in)[i].DeepCopyInto(&(*out)[i])
				}
			}
			(*out)[key] = outVal
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelGroup.
func (in MappingLabelGroup) DeepCopy() MappingLabelGroup {
	if in == nil {
		return nil
	}
	out := new(MappingLabelGroup)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in MappingLabelGroupsArray) DeepCopyInto(out *MappingLabelGroupsArray) {
	{
		in := &in
		*out = make(MappingLabelGroupsArray, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = make(MappingLabelGroup, len(*in))
				for key, val := range *in {
					var outVal []MappingLabelSpecifier
					if val == nil {
						(*out)[key] = nil
					} else {
						inVal := (*in)[key]
						in, out := &inVal, &outVal
						*out = make(MappingLabelsArray, len(*in))
						for i := range *in {
							(*in)[i].DeepCopyInto(&(*out)[i])
						}
					}
					(*out)[key] = outVal
				}
			}
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelGroupsArray.
func (in MappingLabelGroupsArray) DeepCopy() MappingLabelGroupsArray {
	if in == nil {
		return nil
	}
	out := new(MappingLabelGroupsArray)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingLabelSpecifier) DeepCopyInto(out *MappingLabelSpecifier) {
	*out = *in
	if in.SourceCluster != nil {
		in, out := &in.SourceCluster, &out.SourceCluster
		*out = new(MappingLabelSpecifier_SourceCluster)
		**out = **in
	}
	if in.DestinationCluster != nil {
		in, out := &in.DestinationCluster, &out.DestinationCluster
		*out = new(MappingLabelSpecifier_DestinationCluster)
		**out = **in
	}
	if in.RequestHeaders != nil {
		in, out := &in.RequestHeaders, &out.RequestHeaders
		*out = new(MappingLabelSpecifier_RequestHeaders)
		(*in).DeepCopyInto(*out)
	}
	if in.RemoteAddress != nil {
		in, out := &in.RemoteAddress, &out.RemoteAddress
		*out = new(MappingLabelSpecifier_RemoteAddress)
		**out = **in
	}
	if in.GenericKey != nil {
		in, out := &in.GenericKey, &out.GenericKey
		*out = new(MappingLabelSpecifier_GenericKey)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelSpecifier.
func (in *MappingLabelSpecifier) DeepCopy() *MappingLabelSpecifier {
	if in == nil {
		return nil
	}
	out := new(MappingLabelSpecifier)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingLabelSpecifier_DestinationCluster) DeepCopyInto(out *MappingLabelSpecifier_DestinationCluster) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelSpecifier_DestinationCluster.
func (in *MappingLabelSpecifier_DestinationCluster) DeepCopy() *MappingLabelSpecifier_DestinationCluster {
	if in == nil {
		return nil
	}
	out := new(MappingLabelSpecifier_DestinationCluster)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingLabelSpecifier_GenericKey) DeepCopyInto(out *MappingLabelSpecifier_GenericKey) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelSpecifier_GenericKey.
func (in *MappingLabelSpecifier_GenericKey) DeepCopy() *MappingLabelSpecifier_GenericKey {
	if in == nil {
		return nil
	}
	out := new(MappingLabelSpecifier_GenericKey)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingLabelSpecifier_RemoteAddress) DeepCopyInto(out *MappingLabelSpecifier_RemoteAddress) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelSpecifier_RemoteAddress.
func (in *MappingLabelSpecifier_RemoteAddress) DeepCopy() *MappingLabelSpecifier_RemoteAddress {
	if in == nil {
		return nil
	}
	out := new(MappingLabelSpecifier_RemoteAddress)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingLabelSpecifier_RequestHeaders) DeepCopyInto(out *MappingLabelSpecifier_RequestHeaders) {
	*out = *in
	if in.OmitIfNotPresent != nil {
		in, out := &in.OmitIfNotPresent, &out.OmitIfNotPresent
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelSpecifier_RequestHeaders.
func (in *MappingLabelSpecifier_RequestHeaders) DeepCopy() *MappingLabelSpecifier_RequestHeaders {
	if in == nil {
		return nil
	}
	out := new(MappingLabelSpecifier_RequestHeaders)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingLabelSpecifier_SourceCluster) DeepCopyInto(out *MappingLabelSpecifier_SourceCluster) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelSpecifier_SourceCluster.
func (in *MappingLabelSpecifier_SourceCluster) DeepCopy() *MappingLabelSpecifier_SourceCluster {
	if in == nil {
		return nil
	}
	out := new(MappingLabelSpecifier_SourceCluster)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in MappingLabelsArray) DeepCopyInto(out *MappingLabelsArray) {
	{
		in := &in
		*out = make(MappingLabelsArray, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingLabelsArray.
func (in MappingLabelsArray) DeepCopy() MappingLabelsArray {
	if in == nil {
		return nil
	}
	out := new(MappingLabelsArray)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingList) DeepCopyInto(out *MappingList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Mapping, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingList.
func (in *MappingList) DeepCopy() *MappingList {
	if in == nil {
		return nil
	}
	out := new(MappingList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *MappingList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingSpec) DeepCopyInto(out *MappingSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.PrefixRegex != nil {
		in, out := &in.PrefixRegex, &out.PrefixRegex
		*out = new(bool)
		**out = **in
	}
	if in.PrefixExact != nil {
		in, out := &in.PrefixExact, &out.PrefixExact
		*out = new(bool)
		**out = **in
	}
	if in.AddRequestHeaders != nil {
		in, out := &in.AddRequestHeaders, &out.AddRequestHeaders
		*out = new(map[string]AddedHeader)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]AddedHeader, len(*in))
			for key, val := range *in {
				(*out)[key] = *val.DeepCopy()
			}
		}
	}
	if in.AddResponseHeaders != nil {
		in, out := &in.AddResponseHeaders, &out.AddResponseHeaders
		*out = new(map[string]AddedHeader)
		if **in != nil {
			in, out := *in, *out
			*out = make(map[string]AddedHeader, len(*in))
			for key, val := range *in {
				(*out)[key] = *val.DeepCopy()
			}
		}
	}
	if in.AddLinkerdHeaders != nil {
		in, out := &in.AddLinkerdHeaders, &out.AddLinkerdHeaders
		*out = new(bool)
		**out = **in
	}
	if in.AutoHostRewrite != nil {
		in, out := &in.AutoHostRewrite, &out.AutoHostRewrite
		*out = new(bool)
		**out = **in
	}
	if in.CaseSensitive != nil {
		in, out := &in.CaseSensitive, &out.CaseSensitive
		*out = new(bool)
		**out = **in
	}
	if in.Docs != nil {
		in, out := &in.Docs, &out.Docs
		*out = new(DocsInfo)
		(*in).DeepCopyInto(*out)
	}
	if in.EnableIPv4 != nil {
		in, out := &in.EnableIPv4, &out.EnableIPv4
		*out = new(bool)
		**out = **in
	}
	if in.EnableIPv6 != nil {
		in, out := &in.EnableIPv6, &out.EnableIPv6
		*out = new(bool)
		**out = **in
	}
	if in.CircuitBreakers != nil {
		in, out := &in.CircuitBreakers, &out.CircuitBreakers
		*out = make([]*CircuitBreaker, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(CircuitBreaker)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.KeepAlive != nil {
		in, out := &in.KeepAlive, &out.KeepAlive
		*out = new(KeepAlive)
		(*in).DeepCopyInto(*out)
	}
	if in.CORS != nil {
		in, out := &in.CORS, &out.CORS
		*out = new(CORS)
		(*in).DeepCopyInto(*out)
	}
	if in.RetryPolicy != nil {
		in, out := &in.RetryPolicy, &out.RetryPolicy
		*out = new(RetryPolicy)
		(*in).DeepCopyInto(*out)
	}
	if in.RespectDNSTTL != nil {
		in, out := &in.RespectDNSTTL, &out.RespectDNSTTL
		*out = new(bool)
		**out = **in
	}
	if in.GRPC != nil {
		in, out := &in.GRPC, &out.GRPC
		*out = new(bool)
		**out = **in
	}
	if in.HostRedirect != nil {
		in, out := &in.HostRedirect, &out.HostRedirect
		*out = new(bool)
		**out = **in
	}
	if in.MethodRegex != nil {
		in, out := &in.MethodRegex, &out.MethodRegex
		*out = new(bool)
		**out = **in
	}
	if in.RegexRedirect != nil {
		in, out := &in.RegexRedirect, &out.RegexRedirect
		*out = new(RegexMap)
		**out = **in
	}
	if in.RedirectResponseCode != nil {
		in, out := &in.RedirectResponseCode, &out.RedirectResponseCode
		*out = new(int)
		**out = **in
	}
	if in.Precedence != nil {
		in, out := &in.Precedence, &out.Precedence
		*out = new(int)
		**out = **in
	}
	if in.RemoveRequestHeaders != nil {
		in, out := &in.RemoveRequestHeaders, &out.RemoveRequestHeaders
		*out = new([]string)
		if **in != nil {
			in, out := *in, *out
			*out = make([]string, len(*in))
			copy(*out, *in)
		}
	}
	if in.RemoveResponseHeaders != nil {
		in, out := &in.RemoveResponseHeaders, &out.RemoveResponseHeaders
		*out = new([]string)
		if **in != nil {
			in, out := *in, *out
			*out = make([]string, len(*in))
			copy(*out, *in)
		}
	}
	if in.Rewrite != nil {
		in, out := &in.Rewrite, &out.Rewrite
		*out = new(string)
		**out = **in
	}
	if in.RegexRewrite != nil {
		in, out := &in.RegexRewrite, &out.RegexRewrite
		*out = new(RegexMap)
		**out = **in
	}
	if in.Shadow != nil {
		in, out := &in.Shadow, &out.Shadow
		*out = new(bool)
		**out = **in
	}
	if in.ConnectTimeout != nil {
		in, out := &in.ConnectTimeout, &out.ConnectTimeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.ClusterIdleTimeout != nil {
		in, out := &in.ClusterIdleTimeout, &out.ClusterIdleTimeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.ClusterMaxConnectionLifetime != nil {
		in, out := &in.ClusterMaxConnectionLifetime, &out.ClusterMaxConnectionLifetime
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.Timeout != nil {
		in, out := &in.Timeout, &out.Timeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.IdleTimeout != nil {
		in, out := &in.IdleTimeout, &out.IdleTimeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.HealthChecks != nil {
		in, out := &in.HealthChecks, &out.HealthChecks
		*out = make([]HealthCheck, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.DeprecatedUseWebsocket != nil {
		in, out := &in.DeprecatedUseWebsocket, &out.DeprecatedUseWebsocket
		*out = new(bool)
		**out = **in
	}
	if in.AllowUpgrade != nil {
		in, out := &in.AllowUpgrade, &out.AllowUpgrade
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Weight != nil {
		in, out := &in.Weight, &out.Weight
		*out = new(int)
		**out = **in
	}
	if in.BypassAuth != nil {
		in, out := &in.BypassAuth, &out.BypassAuth
		*out = new(bool)
		**out = **in
	}
	if in.AuthContextExtensions != nil {
		in, out := &in.AuthContextExtensions, &out.AuthContextExtensions
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.BypassErrorResponseOverrides != nil {
		in, out := &in.BypassErrorResponseOverrides, &out.BypassErrorResponseOverrides
		*out = new(bool)
		**out = **in
	}
	if in.ErrorResponseOverrides != nil {
		in, out := &in.ErrorResponseOverrides, &out.ErrorResponseOverrides
		*out = make([]ErrorResponseOverride, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Modules != nil {
		in, out := &in.Modules, &out.Modules
		*out = make([]UntypedDict, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.DeprecatedHostRegex != nil {
		in, out := &in.DeprecatedHostRegex, &out.DeprecatedHostRegex
		*out = new(bool)
		**out = **in
	}
	if in.Headers != nil {
		in, out := &in.Headers, &out.Headers
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.RegexHeaders != nil {
		in, out := &in.RegexHeaders, &out.RegexHeaders
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.Labels != nil {
		in, out := &in.Labels, &out.Labels
		*out = make(DomainMap, len(*in))
		for key, val := range *in {
			var outVal []MappingLabelGroup
			if val == nil {
				(*out)[key] = nil
			} else {
				inVal := (*in)[key]
				in, out := &inVal, &outVal
				*out = make(MappingLabelGroupsArray, len(*in))
				for i := range *in {
					if (*in)[i] != nil {
						in, out := &(*in)[i], &(*out)[i]
						*out = make(MappingLabelGroup, len(*in))
						for key, val := range *in {
							var outVal []MappingLabelSpecifier
							if val == nil {
								(*out)[key] = nil
							} else {
								inVal := (*in)[key]
								in, out := &inVal, &outVal
								*out = make(MappingLabelsArray, len(*in))
								for i := range *in {
									(*in)[i].DeepCopyInto(&(*out)[i])
								}
							}
							(*out)[key] = outVal
						}
					}
				}
			}
			(*out)[key] = outVal
		}
	}
	if in.EnvoyOverride != nil {
		in, out := &in.EnvoyOverride, &out.EnvoyOverride
		*out = new(UntypedDict)
		(*in).DeepCopyInto(*out)
	}
	if in.LoadBalancer != nil {
		in, out := &in.LoadBalancer, &out.LoadBalancer
		*out = new(LoadBalancer)
		(*in).DeepCopyInto(*out)
	}
	if in.QueryParameters != nil {
		in, out := &in.QueryParameters, &out.QueryParameters
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.RegexQueryParameters != nil {
		in, out := &in.RegexQueryParameters, &out.RegexQueryParameters
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.V2ExplicitTLS != nil {
		in, out := &in.V2ExplicitTLS, &out.V2ExplicitTLS
		*out = new(V2ExplicitTLS)
		(*in).DeepCopyInto(*out)
	}
	if in.V2BoolHeaders != nil {
		in, out := &in.V2BoolHeaders, &out.V2BoolHeaders
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.V2BoolQueryParameters != nil {
		in, out := &in.V2BoolQueryParameters, &out.V2BoolQueryParameters
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingSpec.
func (in *MappingSpec) DeepCopy() *MappingSpec {
	if in == nil {
		return nil
	}
	out := new(MappingSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MappingStatus) DeepCopyInto(out *MappingStatus) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MappingStatus.
func (in *MappingStatus) DeepCopy() *MappingStatus {
	if in == nil {
		return nil
	}
	out := new(MappingStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MillisecondDuration) DeepCopyInto(out *MillisecondDuration) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MillisecondDuration.
func (in *MillisecondDuration) DeepCopy() *MillisecondDuration {
	if in == nil {
		return nil
	}
	out := new(MillisecondDuration)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Module) DeepCopyInto(out *Module) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Module.
func (in *Module) DeepCopy() *Module {
	if in == nil {
		return nil
	}
	out := new(Module)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Module) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ModuleList) DeepCopyInto(out *ModuleList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Module, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ModuleList.
func (in *ModuleList) DeepCopy() *ModuleList {
	if in == nil {
		return nil
	}
	out := new(ModuleList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *ModuleList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ModuleSpec) DeepCopyInto(out *ModuleSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	in.Config.DeepCopyInto(&out.Config)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ModuleSpec.
func (in *ModuleSpec) DeepCopy() *ModuleSpec {
	if in == nil {
		return nil
	}
	out := new(ModuleSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NamespaceBindingType) DeepCopyInto(out *NamespaceBindingType) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NamespaceBindingType.
func (in *NamespaceBindingType) DeepCopy() *NamespaceBindingType {
	if in == nil {
		return nil
	}
	out := new(NamespaceBindingType)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *PreviewURLSpec) DeepCopyInto(out *PreviewURLSpec) {
	*out = *in
	if in.Enabled != nil {
		in, out := &in.Enabled, &out.Enabled
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new PreviewURLSpec.
func (in *PreviewURLSpec) DeepCopy() *PreviewURLSpec {
	if in == nil {
		return nil
	}
	out := new(PreviewURLSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RateLimitGRPCConfig) DeepCopyInto(out *RateLimitGRPCConfig) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RateLimitGRPCConfig.
func (in *RateLimitGRPCConfig) DeepCopy() *RateLimitGRPCConfig {
	if in == nil {
		return nil
	}
	out := new(RateLimitGRPCConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RateLimitService) DeepCopyInto(out *RateLimitService) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RateLimitService.
func (in *RateLimitService) DeepCopy() *RateLimitService {
	if in == nil {
		return nil
	}
	out := new(RateLimitService)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *RateLimitService) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RateLimitServiceList) DeepCopyInto(out *RateLimitServiceList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]RateLimitService, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RateLimitServiceList.
func (in *RateLimitServiceList) DeepCopy() *RateLimitServiceList {
	if in == nil {
		return nil
	}
	out := new(RateLimitServiceList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *RateLimitServiceList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RateLimitServiceSpec) DeepCopyInto(out *RateLimitServiceSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.Timeout != nil {
		in, out := &in.Timeout, &out.Timeout
		*out = new(MillisecondDuration)
		**out = **in
	}
	if in.GRPC != nil {
		in, out := &in.GRPC, &out.GRPC
		*out = new(RateLimitGRPCConfig)
		**out = **in
	}
	if in.V2ExplicitTLS != nil {
		in, out := &in.V2ExplicitTLS, &out.V2ExplicitTLS
		*out = new(V2ExplicitTLS)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RateLimitServiceSpec.
func (in *RateLimitServiceSpec) DeepCopy() *RateLimitServiceSpec {
	if in == nil {
		return nil
	}
	out := new(RateLimitServiceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RegexMap) DeepCopyInto(out *RegexMap) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RegexMap.
func (in *RegexMap) DeepCopy() *RegexMap {
	if in == nil {
		return nil
	}
	out := new(RegexMap)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RequestPolicy) DeepCopyInto(out *RequestPolicy) {
	*out = *in
	in.Insecure.DeepCopyInto(&out.Insecure)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RequestPolicy.
func (in *RequestPolicy) DeepCopy() *RequestPolicy {
	if in == nil {
		return nil
	}
	out := new(RequestPolicy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RetryPolicy) DeepCopyInto(out *RetryPolicy) {
	*out = *in
	if in.NumRetries != nil {
		in, out := &in.NumRetries, &out.NumRetries
		*out = new(int)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RetryPolicy.
func (in *RetryPolicy) DeepCopy() *RetryPolicy {
	if in == nil {
		return nil
	}
	out := new(RetryPolicy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SecondDuration) DeepCopyInto(out *SecondDuration) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SecondDuration.
func (in *SecondDuration) DeepCopy() *SecondDuration {
	if in == nil {
		return nil
	}
	out := new(SecondDuration)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *StatusRange) DeepCopyInto(out *StatusRange) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new StatusRange.
func (in *StatusRange) DeepCopy() *StatusRange {
	if in == nil {
		return nil
	}
	out := new(StatusRange)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TCPMapping) DeepCopyInto(out *TCPMapping) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TCPMapping.
func (in *TCPMapping) DeepCopy() *TCPMapping {
	if in == nil {
		return nil
	}
	out := new(TCPMapping)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TCPMapping) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TCPMappingList) DeepCopyInto(out *TCPMappingList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]TCPMapping, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TCPMappingList.
func (in *TCPMappingList) DeepCopy() *TCPMappingList {
	if in == nil {
		return nil
	}
	out := new(TCPMappingList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TCPMappingList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TCPMappingSpec) DeepCopyInto(out *TCPMappingSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.EnableIPv4 != nil {
		in, out := &in.EnableIPv4, &out.EnableIPv4
		*out = new(bool)
		**out = **in
	}
	if in.EnableIPv6 != nil {
		in, out := &in.EnableIPv6, &out.EnableIPv6
		*out = new(bool)
		**out = **in
	}
	if in.CircuitBreakers != nil {
		in, out := &in.CircuitBreakers, &out.CircuitBreakers
		*out = make([]CircuitBreaker, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Weight != nil {
		in, out := &in.Weight, &out.Weight
		*out = new(int)
		**out = **in
	}
	if in.V2ExplicitTLS != nil {
		in, out := &in.V2ExplicitTLS, &out.V2ExplicitTLS
		*out = new(V2ExplicitTLS)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TCPMappingSpec.
func (in *TCPMappingSpec) DeepCopy() *TCPMappingSpec {
	if in == nil {
		return nil
	}
	out := new(TCPMappingSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TLSConfig) DeepCopyInto(out *TLSConfig) {
	*out = *in
	if in.CertRequired != nil {
		in, out := &in.CertRequired, &out.CertRequired
		*out = new(bool)
		**out = **in
	}
	if in.CipherSuites != nil {
		in, out := &in.CipherSuites, &out.CipherSuites
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ECDHCurves != nil {
		in, out := &in.ECDHCurves, &out.ECDHCurves
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.RedirectCleartextFrom != nil {
		in, out := &in.RedirectCleartextFrom, &out.RedirectCleartextFrom
		*out = new(int)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TLSConfig.
func (in *TLSConfig) DeepCopy() *TLSConfig {
	if in == nil {
		return nil
	}
	out := new(TLSConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TLSContext) DeepCopyInto(out *TLSContext) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TLSContext.
func (in *TLSContext) DeepCopy() *TLSContext {
	if in == nil {
		return nil
	}
	out := new(TLSContext)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TLSContext) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TLSContextList) DeepCopyInto(out *TLSContextList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]TLSContext, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TLSContextList.
func (in *TLSContextList) DeepCopy() *TLSContextList {
	if in == nil {
		return nil
	}
	out := new(TLSContextList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TLSContextList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TLSContextSpec) DeepCopyInto(out *TLSContextSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.Hosts != nil {
		in, out := &in.Hosts, &out.Hosts
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.CertRequired != nil {
		in, out := &in.CertRequired, &out.CertRequired
		*out = new(bool)
		**out = **in
	}
	if in.CipherSuites != nil {
		in, out := &in.CipherSuites, &out.CipherSuites
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ECDHCurves != nil {
		in, out := &in.ECDHCurves, &out.ECDHCurves
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.SecretNamespacing != nil {
		in, out := &in.SecretNamespacing, &out.SecretNamespacing
		*out = new(bool)
		**out = **in
	}
	if in.RedirectCleartextFrom != nil {
		in, out := &in.RedirectCleartextFrom, &out.RedirectCleartextFrom
		*out = new(int)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TLSContextSpec.
func (in *TLSContextSpec) DeepCopy() *TLSContextSpec {
	if in == nil {
		return nil
	}
	out := new(TLSContextSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TraceConfig) DeepCopyInto(out *TraceConfig) {
	*out = *in
	if in.PropagationModes != nil {
		in, out := &in.PropagationModes, &out.PropagationModes
		*out = make([]PropagationMode, len(*in))
		copy(*out, *in)
	}
	if in.TraceID128Bit != nil {
		in, out := &in.TraceID128Bit, &out.TraceID128Bit
		*out = new(bool)
		**out = **in
	}
	if in.SharedSpanContext != nil {
		in, out := &in.SharedSpanContext, &out.SharedSpanContext
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TraceConfig.
func (in *TraceConfig) DeepCopy() *TraceConfig {
	if in == nil {
		return nil
	}
	out := new(TraceConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TraceSampling) DeepCopyInto(out *TraceSampling) {
	*out = *in
	if in.Client != nil {
		in, out := &in.Client, &out.Client
		*out = new(int)
		**out = **in
	}
	if in.Random != nil {
		in, out := &in.Random, &out.Random
		*out = new(int)
		**out = **in
	}
	if in.Overall != nil {
		in, out := &in.Overall, &out.Overall
		*out = new(int)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TraceSampling.
func (in *TraceSampling) DeepCopy() *TraceSampling {
	if in == nil {
		return nil
	}
	out := new(TraceSampling)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TracingCustomTag) DeepCopyInto(out *TracingCustomTag) {
	*out = *in
	if in.Literal != nil {
		in, out := &in.Literal, &out.Literal
		*out = new(TracingCustomTagTypeLiteral)
		**out = **in
	}
	if in.Environment != nil {
		in, out := &in.Environment, &out.Environment
		*out = new(TracingCustomTagTypeEnvironment)
		(*in).DeepCopyInto(*out)
	}
	if in.Header != nil {
		in, out := &in.Header, &out.Header
		*out = new(TracingCustomTagTypeRequestHeader)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TracingCustomTag.
func (in *TracingCustomTag) DeepCopy() *TracingCustomTag {
	if in == nil {
		return nil
	}
	out := new(TracingCustomTag)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TracingCustomTagTypeEnvironment) DeepCopyInto(out *TracingCustomTagTypeEnvironment) {
	*out = *in
	if in.DefaultValue != nil {
		in, out := &in.DefaultValue, &out.DefaultValue
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TracingCustomTagTypeEnvironment.
func (in *TracingCustomTagTypeEnvironment) DeepCopy() *TracingCustomTagTypeEnvironment {
	if in == nil {
		return nil
	}
	out := new(TracingCustomTagTypeEnvironment)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TracingCustomTagTypeLiteral) DeepCopyInto(out *TracingCustomTagTypeLiteral) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TracingCustomTagTypeLiteral.
func (in *TracingCustomTagTypeLiteral) DeepCopy() *TracingCustomTagTypeLiteral {
	if in == nil {
		return nil
	}
	out := new(TracingCustomTagTypeLiteral)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TracingCustomTagTypeRequestHeader) DeepCopyInto(out *TracingCustomTagTypeRequestHeader) {
	*out = *in
	if in.DefaultValue != nil {
		in, out := &in.DefaultValue, &out.DefaultValue
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TracingCustomTagTypeRequestHeader.
func (in *TracingCustomTagTypeRequestHeader) DeepCopy() *TracingCustomTagTypeRequestHeader {
	if in == nil {
		return nil
	}
	out := new(TracingCustomTagTypeRequestHeader)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TracingService) DeepCopyInto(out *TracingService) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TracingService.
func (in *TracingService) DeepCopy() *TracingService {
	if in == nil {
		return nil
	}
	out := new(TracingService)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TracingService) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TracingServiceList) DeepCopyInto(out *TracingServiceList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]TracingService, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TracingServiceList.
func (in *TracingServiceList) DeepCopy() *TracingServiceList {
	if in == nil {
		return nil
	}
	out := new(TracingServiceList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *TracingServiceList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TracingServiceSpec) DeepCopyInto(out *TracingServiceSpec) {
	*out = *in
	if in.AmbassadorID != nil {
		in, out := &in.AmbassadorID, &out.AmbassadorID
		*out = make(AmbassadorID, len(*in))
		copy(*out, *in)
	}
	if in.Sampling != nil {
		in, out := &in.Sampling, &out.Sampling
		*out = new(TraceSampling)
		(*in).DeepCopyInto(*out)
	}
	if in.DeprecatedTagHeaders != nil {
		in, out := &in.DeprecatedTagHeaders, &out.DeprecatedTagHeaders
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.CustomTags != nil {
		in, out := &in.CustomTags, &out.CustomTags
		*out = make([]TracingCustomTag, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Config != nil {
		in, out := &in.Config, &out.Config
		*out = new(TraceConfig)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TracingServiceSpec.
func (in *TracingServiceSpec) DeepCopy() *TracingServiceSpec {
	if in == nil {
		return nil
	}
	out := new(TracingServiceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *UntypedDict) DeepCopyInto(out *UntypedDict) {
	*out = *in
	if in.Values != nil {
		in, out := &in.Values, &out.Values
		*out = make(map[string]json.RawMessage, len(*in))
		for key, val := range *in {
			var outVal []byte
			if val == nil {
				(*out)[key] = nil
			} else {
				inVal := (*in)[key]
				in, out := &inVal, &outVal
				*out = make(json.RawMessage, len(*in))
				copy(*out, *in)
			}
			(*out)[key] = outVal
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new UntypedDict.
func (in *UntypedDict) DeepCopy() *UntypedDict {
	if in == nil {
		return nil
	}
	out := new(UntypedDict)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *V2ExplicitTLS) DeepCopyInto(out *V2ExplicitTLS) {
	*out = *in
	if in.ServiceScheme != nil {
		in, out := &in.ServiceScheme, &out.ServiceScheme
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new V2ExplicitTLS.
func (in *V2ExplicitTLS) DeepCopy() *V2ExplicitTLS {
	if in == nil {
		return nil
	}
	out := new(V2ExplicitTLS)
	in.DeepCopyInto(out)
	return out
}
